<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="en">
<head>
	<title>CarbonPHP Documentation</title>
	<style type="text/css">
		* {
			margin: 0;
			padding: 0;
		}

		html {
			font-family: "Lucida Sans Unicode", "Lucida Grande";
			font-size: 14px;
		}

		body {
			background: #fff;
			color: #666;
		}

		h1 {
			font-size: 15px;
			font-weight: bold;
			margin: 0 0 5px 0;
		}

		h2 {
			font-size: 13px;
			font-weight: bold;
			margin: 5px 0 5px 0;
		}

		ol, ul {
			margin: 10px 0 10px 0;
			list-style-position: inside;
		}

		p {
			margin: 5px 0 5px 0;
		}

		.content {
			border: 1px dotted #444;
			margin: 10px;
			padding: 10px;
			text-align: justify;
			width: 700px;
		}

		.example {
			border: 1px solid #ccc;
			background: #eee;
			margin: 10px;
			padding: 10px;
			text-align: left;
		}
	</style>
</head>

<body>
	<div class="content">
		<h1>Database Configuration</h1>

		<p>There is a configuration file that lets you store your database connection details.  The configuration file
		is in the <b>application/config/database.php</b> file.</p>

		<p>The configuration settings are stored in a multi-dimensional array with the following prototype.</p>

		<div class="example">
			$database['default']['hostname'] = 'localhost';<br />
			$database['default']['username'] = 'root';<br />
			$database['default']['password'] = '';<br />
			$database['default']['database'] = 'database_name';<br />
			$database['default']['dbdriver'] = 'mysql';<br />
			$database['default']['dbprefix'] = '';<br />
			$database['default']['pconnect'] = true;<br />
			$database['default']['db_debug'] = false;<br />
			$database['default']['cache_on'] = false;<br />
			$database['default']['cachedir'] = '';<br />
			$database['default']['char_set'] = 'utf8';<br />
			$database['default']['dbcollat'] = 'utf8_general_ci';<br />
		</div>

		<p>The reason a multi-dimensional array is used is that it allows more than one set of database connection
		settings to be stored.  Below is an example second set of connection details.</p>

		<div class="example">
			$database['test']['hostname'] = 'localhost';<br />
			$database['test']['username'] = 'root';<br />
			$database['test']['password'] = '';<br />
			$database['test']['database'] = 'database_name';<br />
			$database['test']['dbdriver'] = 'mysql';<br />
			$database['test']['dbprefix'] = '';<br />
			$database['test']['pconnect'] = true;<br />
			$database['test']['db_debug'] = false;<br />
			$database['test']['cache_on'] = false;<br />
			$database['test']['cachedir'] = '';<br />
			$database['test']['char_set'] = 'utf8';<br />
			$database['test']['dbcollat'] = 'utf8_general_ci';<br />
		</div>

		<p>To globally tell CarbonPHP which connection settings to use you just set the	<b>$active_group</b>
		variable.</p>

		<div class="example">
			$active_group = 'test';
		</div>
	</div>

	<div class="content">
		<h1>Active Record</h1>
		
		<p>The Active Record class is globally enabled or disabled by setting the <b>$active_record</b> variable in the database
		configuration file to true or false.  If you are not using the active record class, setting it to false will use fewer resources
		when the database classes are initialised.</p>

		<div class="example">
			$active_record = true;
		</div>
	</div>

	<div class="content">
		<h1>Configuration Options</h1>

		<ul>
			<li><b>hostname</b> - the hostname of the database server.</li>
			<li><b>username</b> - the username used to connect to the database.</li>
			<li><b>password</b> - the password used to connect to the database.</li>
			<li><b>database</b> - the name of the database you want to connect to.</li>
			<li><b>dbdriver</b> - the type of database i.e. mysql, postgre, mssql.</li>
			<li><b>dbpreifx</b> - the optional table prefix which will be added when running active record queries.</li>
			<li><b>pconnect</b> - the option to use a persistant database connection.</li>
			<li><b>db_debug</b> - the option to show database errors or not.</li>
			<li><b>cache_on</b> - the option whether database query caching is enabled.</li>
			<li><b>cachedir</b> - the absolute path to the directory to use for query caching.</li>
			<li><b>char_set</b> - the character set used in communicating with the database.</li>
			<li><b>dbcollat</b> - the character collation used in communication with the database.</li>
			<li><b>port</b> - the database port number, only used for the postgre driver.</li>
		</ul>

		<p><i>Note</i>: depending on which database driver you are using not all values will be needed.  For example
		when you are using the SQLite driver you will not need to supply a username or password, and the database
		name will be the path to the database file.</p>
	</div>
</body>

</html>
